summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authordavidovski <david@davidovski.xyz>2022-03-13 18:14:47 +0000
committerdavidovski <david@davidovski.xyz>2022-03-13 18:14:47 +0000
commit5211a48f4001e97e343660ac1e6dcf7b68325ee1 (patch)
treec06acd04548621810fae14df014cc2168cb888ae
parente666911d1eb410a172b532810f4fb8a83504fefe (diff)
added mkinitramfs
-rw-r--r--Makefile4
-rw-r--r--mkinitrd/initramfs-init.sh110
-rwxr-xr-xmkinitrd/mkinitramfs.sh81
-rw-r--r--xi/inittab27
4 files changed, 222 insertions, 0 deletions
diff --git a/Makefile b/Makefile
index 30b9c6d..774d41b 100644
--- a/Makefile
+++ b/Makefile
@@ -22,3 +22,7 @@ utmps:
mkdir -p $(DESTDIR)/var/log/utmps
mv $(DESTDIR)/var/log/wtmp /var/log/utmps/
+install-mkinitramfs: mkinitrd/mkinitramfs.sh mkinitrd/initramfs-init.sh
+ install -m755 mkinitrd/mkinitramfs.sh ${DESTDIR}${PREFIX}/bin/mkinitramfs
+ install -m755 mkinitrd/initramfs-init.sh ${DESTDIR}${PREFIX}/bin/initramfs-init
+
diff --git a/mkinitrd/initramfs-init.sh b/mkinitrd/initramfs-init.sh
new file mode 100644
index 0000000..9353e0f
--- /dev/null
+++ b/mkinitrd/initramfs-init.sh
@@ -0,0 +1,110 @@
+#!/bin/sh
+
+PATH=/bin:/usr/bin:/sbin:/usr/sbin
+export PATH
+
+echo "Loading system..."
+
+problem()
+{
+ printf "Encountered a problem!\n\nDropping you to a shell.\n\n"
+ sh
+}
+
+no_device()
+{
+ printf "The device %s, which is supposed to contain the\n" $1
+ printf "root file system, does not exist.\n"
+ printf "Please fix this problem and exit this shell.\n\n"
+}
+
+no_mount()
+{
+ printf "Could not mount device %s\n" $1
+ printf "Sleeping forever. Please reboot and fix the kernel command line.\n\n"
+ printf "Maybe the device is formatted with an unsupported file system?\n\n"
+ printf "Or maybe filesystem type autodetection went wrong, in which case\n"
+ printf "you should add the rootfstype=... parameter to the kernel command line.\n\n"
+ printf "Available partitions:\n"
+}
+
+do_mount_root()
+{
+ mkdir /.root
+ [ -n "$rootflags" ] && rootflags="$rootflags,"
+ rootflags="$rootflags$ro"
+
+ case "$root" in
+ /dev/* ) device=$root ;;
+ UUID=* ) eval $root; device="/dev/disk/by-uuid/$UUID" ;;
+ LABEL=*) eval $root; device="/dev/disk/by-label/$LABEL" ;;
+ "" ) echo "No root device specified." ; problem ;;
+ esac
+
+ while [ ! -b "$device" ] ; do
+ no_device $device
+ problem
+ done
+
+ if ! mount -n -t "$rootfstype" -o "$rootflags" "$device" /.root ; then
+ no_mount $device
+ cat /proc/partitions
+ while true ; do sleep 10000 ; done
+ else
+ echo "Successfully mounted device $root"
+ fi
+}
+
+init=/sbin/init
+root=
+rootdelay=
+rootfstype=auto
+ro="ro"
+rootflags=
+device=
+
+mount -n -t devtmpfs devtmpfs /dev
+mount -n -t proc proc /proc
+mount -n -t sysfs sysfs /sys
+mount -n -t tmpfs tmpfs /run
+
+read -r cmdline < /proc/cmdline
+
+for param in $cmdline ; do
+ case $param in
+ init=* ) init=${param#init=} ;;
+ root=* ) root=${param#root=} ;;
+ rootdelay=* ) rootdelay=${param#rootdelay=} ;;
+ rootfstype=*) rootfstype=${param#rootfstype=} ;;
+ rootflags=* ) rootflags=${param#rootflags=} ;;
+ ro ) ro="ro" ;;
+ rw ) ro="rw" ;;
+ esac
+done
+
+# udevd location depends on version
+if [ -x /sbin/udevd ]; then
+ UDEVD=/sbin/udevd
+elif [ -x /lib/udev/udevd ]; then
+ UDEVD=/lib/udev/udevd
+elif [ -x /lib/systemd/systemd-udevd ]; then
+ UDEVD=/lib/systemd/systemd-udevd
+else
+ echo "Cannot find udevd nor systemd-udevd"
+ problem
+fi
+
+${UDEVD} --daemon --resolve-names=never
+udevadm trigger
+udevadm settle
+
+if [ -f /etc/mdadm.conf ] ; then mdadm -As ; fi
+if [ -x /sbin/vgchange ] ; then /sbin/vgchange -a y > /dev/null ; fi
+if [ -n "$rootdelay" ] ; then sleep "$rootdelay" ; fi
+
+do_mount_root
+
+killall -w ${UDEVD##*/}
+
+exec switch_root /.root "$init" "$@"
+
diff --git a/mkinitrd/mkinitramfs.sh b/mkinitrd/mkinitramfs.sh
new file mode 100755
index 0000000..9e32cee
--- /dev/null
+++ b/mkinitrd/mkinitramfs.sh
@@ -0,0 +1,81 @@
+#!/bin/sh
+
+BUILD=/tmp/ramfs
+OUT=${1-/boot/initramfs-linux.img}
+
+
+# create base directory structure
+printf "creating directories..."
+
+[ -e $BUILD ] && rm -rf $BUILD
+mkdir -p $BUILD/tmp
+
+cd $BUILD
+mkdir -p bin dev etc lib proc run sbin sys usr
+mkdir -p lib/firmware lib/modules lib/udev
+mkdir -p etc/modprobe.d etc/udev
+
+ln -s lib lib64
+ln -s ../bin usr/bin
+ln -s ../sbin usr/sbin
+printf "OK\n"
+
+# copy binaries
+printf "populating /bin..."
+for b in dash cat cp dd killall kmod ln ls mkdir \
+ mknod mount rm sed sleep umount uname \
+ basename readlink printf echo udevadm; do
+ cp -a /bin/$b bin/
+done
+ln -s dash bin/sh
+ln -s kmod bin/insmod
+ln -s kmod bin/lsmod
+printf "OK\n"
+
+# create nodes for udev to mount
+printf "creating nodes..."
+mknod -m 600 dev/console c 5 1
+mknod -m 666 dev/null c 1 3
+printf "OK\n"
+
+# Copy udev configuration
+printf "configuring udev..."
+cp /etc/udev/udev.conf etc/udev/
+cp -r /etc/udev/rules.d etc/udev/
+cp -r /lib/udev/* lib/udev/
+printf "OK\n"
+
+# set module order
+touch etc/modprobe.d/modprobe.conf
+
+# copy the init script
+printf "installing init script..."
+cp /sbin/initramfs-init sbin/init
+printf "OK\n"
+
+# copy required libraries
+printf "populating /lib..."
+for l in c acl attr blkid cap kmod lzma mount ncursesw readline z curses history zstd; do
+ cp /lib/lib$l.so lib/
+done
+ln -s libc.so /ld-musl-$(uname -m).so.1
+printf "OK\n"
+
+# copy any firmware
+[ -d /lib/firmware ] && {
+ printf "installing firmware..."
+ cp -r /lib/firmware/* lib/firmware/
+ printf "OK\n"
+}
+
+# copy any modules
+printf "installing modules..."
+cp -r /lib/modules/* lib/modules/
+printf "OK\n"
+
+# create the initramfs image
+printf "creating initramfs image..."
+find ./ | cpio -o -H newc | gzip -9 > $OUT
+printf "OK\n"
+
+printf "Written initramfs image to $OUT\n"
diff --git a/xi/inittab b/xi/inittab
new file mode 100644
index 0000000..c54a0cb
--- /dev/null
+++ b/xi/inittab
@@ -0,0 +1,27 @@
+# Begin /etc/inittab
+
+id:3:initdefault:
+
+si::sysinit:/etc/rc.d/init.d/rc S
+
+l0:0:wait:/etc/rc.d/init.d/rc 0
+l1:S1:wait:/etc/rc.d/init.d/rc 1
+l2:2:wait:/etc/rc.d/init.d/rc 2
+l3:3:wait:/etc/rc.d/init.d/rc 3
+l4:4:wait:/etc/rc.d/init.d/rc 4
+l5:5:wait:/etc/rc.d/init.d/rc 5
+l6:6:wait:/etc/rc.d/init.d/rc 6
+
+ca:12345:ctrlaltdel:/sbin/shutdown -t1 -a -r now
+
+su:S016:once:/sbin/sulogin
+
+1:2345:respawn:/sbin/agetty --noclear tty1 9600
+2:2345:respawn:/sbin/agetty tty2 9600
+3:2345:respawn:/sbin/agetty tty3 9600
+4:2345:respawn:/sbin/agetty tty4 9600
+5:2345:respawn:/sbin/agetty tty5 9600
+6:2345:respawn:/sbin/agetty tty6 9600
+
+# End /etc/inittab
+